/************************************************************************/
/*                                                                      */
/*Double-buffed version of RatingApplet.java                            */
/*                  This Applet is used to calculate and display the    */
/*                  results of public rating for local TV stations      */
/*                                                                      */
/*     Language:    JAVA 1.1.5                                          */
/*     Platform:    Pentium 233 Windows 95                              */
/*  Application:    Homework #3 for CPS606                              */
/*       Author:    Zhengshan Sun  zsun@mailbox.syr.edu                 */
/*       Note  :    Part of this program is borrowed from the class hand*/
/*                  -out "mObjApplet" and except that all the codes are */
/*                  written by myself                                   */
/************************************************************************/
 

import java.applet.*;
import java.awt.*;


public class Hw3a extends Applet implements Runnable {

  // Instance variables:
  int numObj = 11;     // number of objects
  mPoint object[];    // object array
  Thread thread;      // a thread
  Image image;        // for double buffering 
  int frequency[],face;
 
  // Class method:
  public void initObjects() {

  /* initialize object array */
  object = new mPoint[numObj];

  /*Produce random number and calculate frequency*/ 
  frequency = new int [12];
  for (int answer =1; answer < 400; answer++){
  face =1+(int)(Math.random()*11);
  ++frequency[ face ];
  }


    /* initialize  bars */
   
    object[0] = new mbar1(15, 300, 30, 22+frequency[1]*5);
    object[0].setDelta(0, frequency[1]/5);
    object[0].setColor(Color.orange);
    object[1] = new mbar1(55, 300, 30, 22+frequency[3]*5);
    object[1].setDelta(0, frequency[3]/5);
    object[1].setColor(Color.blue);
    object[2] = new mbar1(95, 300, 30, 22+frequency[4]*5);
    object[2].setDelta(0, frequency[4]/5);
    object[2].setColor(Color.magenta);
    object[3] = new mbar1(135, 300, 30, 22+frequency[5]*5);
    object[3].setDelta(0, frequency[5]/5);
    object[3].setColor(Color.pink);
    object[4] = new mbar1(175, 300, 30, 22+frequency[6]*5);
    object[4].setDelta(0, frequency[6]/5);
    object[4].setColor(Color.green);
    object[5] = new mbar1(215, 300, 30, 22+frequency[7]*5);
    object[5].setDelta(0, frequency[7]/5);
    object[5].setColor(Color.red);
    object[6] = new mbar1(255, 300, 30, 22+frequency[8]*5);
    object[6].setDelta(0, frequency[8]/5);
    object[6].setColor(Color.yellow);
    object[7] = new mbar1(295, 300, 30, 22+frequency[9]*5);
    object[7].setDelta(0, frequency[9]/5);
    object[7].setColor(Color.magenta);
    object[8] = new mbar1(335, 300, 30, 22+frequency[10]*5);
    object[8].setDelta(0, frequency[10]/5);
    object[8].setColor(Color.pink);
    object[9] = new mbar1(375, 300, 30, 22+frequency[11]*5);
    object[9].setDelta(0, frequency[11]/5);
    object[9].setColor(Color.green);
    object[10] = new mbar1(415, 300, 30, 22+frequency[2]*5);
    object[10].setDelta(0, frequency[2]/5);
    object[10].setColor(Color.red);


    image = createImage(size().width-25, size().height-29);
  }

  // Override java.applet.Applet.init:
  public void init () {
    initObjects();
  }

  // Override java.applet.Applet.start:
  public void start() {
    if (thread == null) {
      // Reinitialize:
      initObjects();
      thread = new Thread(this);
      thread.start();
    }
  }
  
  // Override java.applet.Applet.stop:
  public void stop() {
    if (thread != null) {
      thread.stop();
      thread = null;
    }
  }
  
  // Implement java.lang.Runnable.run:
  public void run() {
    while(thread != null) {
      // repaint() invokes update():
      repaint();
      try {
        Thread.sleep(200);
      } 
      catch(InterruptedException e) {
        // Do nothing   
      };
    }
  }

  // Override java.awt.Component.update:
  public void update(Graphics g) {
    /* Get Off Screen Graphics Context */
    Graphics og = image.getGraphics(); 
    /* fill background */
    og.setColor(getBackground());
    og.fillRect(1, 1, size().width-2, size().height-2);
    /* draw boundry */
    //og.setColor(getForeground());
  //  og.drawRect(0, 0, size().width-1, size().height-1);
    /* move object */
    for (int i=0; i<numObj; i++) {
      object[i].checkBoundary(bounds());
      object[i].move(og);
      }
    /* user who call getGraphics should call dispose */
    og.dispose();
    g.drawImage(image, 12, 18, this);
 /*set fonts size,clor and draw scale, boader and tile*/
  Font MyFont1 = new Font("TimesRoman", Font.BOLD ,14);
  Font MyFont = new Font("TimesRoman", Font.BOLD ,10);
  g.setColor (Color.red);
  g.setFont(MyFont1);
  g.drawString ("Rating Samples Are Randomly Selected",15,16 );
  g.setFont(MyFont);
  g.setColor (Color.blue);
  g.drawString ("Sampling Number = 400",350,16 );
  g.setColor (Color.black);
  g.drawString ("Chan. 1",23,303 );
  g.drawString ("Chan. 2",63,303 );
  g.drawString ("Chan. 3",103,303 );
  g.drawString ("Chan. 4",143,303 );
  g.drawString ("Chan. 5",183,303 );
  g.drawString ("Chan. 6",223,303 );
  g.drawString ("Chan. 7",263,303 );
  g.drawString ("Chan. 8",303,303 );
  g.drawString ("Chan. 9",343,303 );
  g.drawString ("Chan.10",383,303 );
  g.drawString ("Chan.11",423,303 );
  g.drawString ("50",2,80);
  g.drawString ("40",2,124);
  g.drawString ("30",2,168);
  g.drawString ("20",2,212);
  g.drawString ("10",2,256);
  g.drawString ("50",470,80);
  g.drawString ("40",470,124);
  g.drawString ("30",470,168);
  g.drawString ("20",470,212);
  g.drawString ("10",470,256);
  g.drawString ("60",1,36);
  g.drawString ("60",470,36);
  g.drawLine (1,1,500,1);
  g.drawLine (1,1,1,304);
  g.drawLine (480,1,480,304);
  g.drawLine (1,304,480,304);
  g.drawLine (22,294,454,294);
  }
  
  // Override java.awt.Component.paint:

  public void paint(Graphics g) {


  update(g);
  }
}




